<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Item extends BaseItem
{
  public function getBaseAmount()
  {
    return $this->getUnitaryCost() * $this->getQuantity();
  }
  
  public function getNetAmount()
  {
    return $this->getBaseAmount() - $this->getDiscountAmount();
  }
  
  public function getDiscountAmount()
  {
    return $this->getBaseAmount() * $this->getDiscount() / 100;
  }
  
  public function getTaxAmount($tax_name = null)
  {
    return $this->getNetAmount() * $this->getTaxesPercent($tax_name) / 100;
  }
  
  public function getGrossAmount()
  {
    return $this->getNetAmount() + $this->getTaxAmount();
  }

  public function __call($data, $argument)
  {
    if(strpos($data,'getTaxAmount') === 0 and strlen($data)>12)
    {
      $tax_name = substr($data,12);
      return $this->getTaxAmount($tax_name);
    }
    return parent::__call($data, $argument);
  }

  public function __get($name)
  {
    if(in_array($name,array('base_amount','discount_amount','net_amount','tax_amount','gross_amount')))
    {
      $m = sfInflector::camelize("get_{$name}");
      return $this->$m();
    }
    return parent::__get($name);
  }

  public function __isset($name)
  {
    if(in_array($name,array('base_amount','discount_amount','net_amount','tax_amount','gross_amount')))
    {
      return true;
    }
    return parent::__isset($name);
  }
  
  public function getTaxesPercent($tax_names = null)
  {
    $tax_names = $tax_names ? 
      ( is_array($tax_names) ? 
        array_map(array('CustomerTable', 'slugify'), $tax_names) : 
        array(CustomerTable::slugify($tax_names)) ) : 
      null;
    $total = 0;
    foreach($this->Taxes as $tax)
    {
      if(!$tax_names || in_array(CustomerTable::slugify($tax->name), $tax_names))
      {
        $total += $tax->getValue();
      }
    }
    
    return $total;
  }

  public function getQuantity()
  {
    return (float) $this->_get('quantity');
  }
  
  public function getUnitaryCost()
  {
    return (float) $this->_get('unitary_cost');
  }
}